// FullAccess
resource "azurerm_role_definition" "azure_iot_hub_fullaccess_definition" {
  name              = "azure-iot-hub-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/checkNameAvailability/Action",
      "Microsoft.Devices/checkProvisioningServiceNameAvailability/Action",
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/IotHubs/diagnosticSettings/read",
      "Microsoft.Devices/IotHubs/diagnosticSettings/write",
      "Microsoft.Devices/IotHubs/metricDefinitions/read",
      "Microsoft.Devices/IotHubs/logDefinitions/read",
      "Microsoft.Devices/iotHubs/Read",
      "Microsoft.Devices/iotHubs/Write",
      "Microsoft.Devices/iotHubs/Delete",
      "Microsoft.Devices/iotHubs/listkeys/Action",
      "Microsoft.Devices/iotHubs/exportDevices/Action",
      "Microsoft.Devices/iotHubs/importDevices/Action",
      "Microsoft.Devices/iotHubs/operationresults/Read",
      "Microsoft.Devices/iotHubs/iotHubStats/Read",
      "Microsoft.Devices/iotHubs/skus/Read",
      "Microsoft.Devices/iotHubs/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/iotHubs/jobs/Read",
      "Microsoft.Devices/iotHubs/quotaMetrics/Read",
      "Microsoft.Devices/iotHubs/routing/$testall/Action",
      "Microsoft.Devices/iotHubs/routing/$testnew/Action",
      "Microsoft.Devices/iotHubs/routingEndpointsHealth/Read",
      "Microsoft.Devices/operations/Read",
      "Microsoft.Devices/usages/Read",
      "Microsoft.Devices/operationresults/Read",
      "Microsoft.Devices/iotHubs/certificates/Read",
      "Microsoft.Devices/iotHubs/certificates/Write",
      "Microsoft.Devices/iotHubs/certificates/Delete",
      "Microsoft.Devices/iotHubs/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/iotHubs/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/Read",
      "Microsoft.Devices/provisioningServices/Write",
      "Microsoft.Devices/provisioningServices/Delete",
      "Microsoft.Devices/provisioningServices/listkeys/Action",
      "Microsoft.Devices/provisioningServices/operationresults/Read",
      "Microsoft.Devices/provisioningServices/skus/Read",
      "Microsoft.Devices/provisioningServices/keys/listkeys/Action",
      "Microsoft.Devices/provisioningServices/certificates/Read",
      "Microsoft.Devices/provisioningServices/certificates/Write",
      "Microsoft.Devices/provisioningServices/certificates/Delete",
      "Microsoft.Devices/provisioningServices/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/provisioningServices/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/read",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/write",
      "Microsoft.Devices/provisioningServices/metricDefinitions/read",
      "Microsoft.Devices/provisioningServices/logDefinitions/read",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/IotHubTenants/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/logDefinitions/read",
      "Microsoft.Devices/elasticPools/iotHubTenants/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/listKeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/exportDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/importDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/getStats/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/jobs/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/quotaMetrics/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testall/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testnew/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/routingEndpointsHealth/Read",
      "Microsoft.Devices/iotHubs/eventGridFilters/Write",
      "Microsoft.Devices/iotHubs/eventGridFilters/Read",
      "Microsoft.Devices/iotHubs/eventGridFilters/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/verify/Action",
      "Microsoft.Devices/locations/operationresults/Read",
      "Microsoft.IoTSpaces/register/action",
      "Microsoft.IoTSpaces/Graph/write",
      "Microsoft.IoTSpaces/Graph/read",
      "Microsoft.IoTSpaces/Graph/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_iot_hub_readonly_definition" {
  name              = "azure-iot-hub-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Devices/IotHubs/diagnosticSettings/read",
      "Microsoft.Devices/IotHubs/metricDefinitions/read",
      "Microsoft.Devices/IotHubs/logDefinitions/read",
      "Microsoft.Devices/iotHubs/Read",
      "Microsoft.Devices/iotHubs/operationresults/Read",
      "Microsoft.Devices/iotHubs/iotHubStats/Read",
      "Microsoft.Devices/iotHubs/skus/Read",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/iotHubs/jobs/Read",
      "Microsoft.Devices/iotHubs/quotaMetrics/Read",
      "Microsoft.Devices/iotHubs/routingEndpointsHealth/Read",
      "Microsoft.Devices/operations/Read",
      "Microsoft.Devices/usages/Read",
      "Microsoft.Devices/operationresults/Read",
      "Microsoft.Devices/iotHubs/certificates/Read",
      "Microsoft.Devices/provisioningServices/Read",
      "Microsoft.Devices/provisioningServices/operationresults/Read",
      "Microsoft.Devices/provisioningServices/skus/Read",
      "Microsoft.Devices/provisioningServices/certificates/Read",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/read",
      "Microsoft.Devices/provisioningServices/metricDefinitions/read",
      "Microsoft.Devices/provisioningServices/logDefinitions/read",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/logDefinitions/read",
      "Microsoft.Devices/elasticPools/iotHubTenants/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/getStats/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/jobs/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/quotaMetrics/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/routingEndpointsHealth/Read",
      "Microsoft.Devices/iotHubs/eventGridFilters/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Read",
      "Microsoft.Devices/locations/operationresults/Read",
      "Microsoft.IoTSpaces/Graph/read",
    ]

    not_actions = [
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/checkNameAvailability/Action",
      "Microsoft.Devices/checkProvisioningServiceNameAvailability/Action",
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/IotHubs/diagnosticSettings/write",
      "Microsoft.Devices/iotHubs/Write",
      "Microsoft.Devices/iotHubs/Delete",
      "Microsoft.Devices/iotHubs/listkeys/Action",
      "Microsoft.Devices/iotHubs/exportDevices/Action",
      "Microsoft.Devices/iotHubs/importDevices/Action",
      "Microsoft.Devices/iotHubs/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/iotHubs/routing/$testall/Action",
      "Microsoft.Devices/iotHubs/routing/$testnew/Action",
      "Microsoft.Devices/iotHubs/certificates/Write",
      "Microsoft.Devices/iotHubs/certificates/Delete",
      "Microsoft.Devices/iotHubs/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/iotHubs/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/Write",
      "Microsoft.Devices/provisioningServices/Delete",
      "Microsoft.Devices/provisioningServices/listkeys/Action",
      "Microsoft.Devices/provisioningServices/keys/listkeys/Action",
      "Microsoft.Devices/provisioningServices/certificates/Write",
      "Microsoft.Devices/provisioningServices/certificates/Delete",
      "Microsoft.Devices/provisioningServices/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/provisioningServices/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/write",
      "Microsoft.Devices/elasticPools/iotHubTenants/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/listKeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/exportDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/importDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testall/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testnew/Action",
      "Microsoft.Devices/iotHubs/eventGridFilters/Write",
      "Microsoft.Devices/iotHubs/eventGridFilters/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/verify/Action",
      "Microsoft.IoTSpaces/register/action",
      "Microsoft.IoTSpaces/Graph/write",
      "Microsoft.IoTSpaces/Graph/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_iot_hub_noaccess_definition" {
  name              = "azure-iot-hub-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/checkNameAvailability/Action",
      "Microsoft.Devices/checkProvisioningServiceNameAvailability/Action",
      "Microsoft.Devices/register/action",
      "Microsoft.Devices/IotHubs/diagnosticSettings/read",
      "Microsoft.Devices/IotHubs/diagnosticSettings/write",
      "Microsoft.Devices/IotHubs/metricDefinitions/read",
      "Microsoft.Devices/IotHubs/logDefinitions/read",
      "Microsoft.Devices/iotHubs/Read",
      "Microsoft.Devices/iotHubs/Write",
      "Microsoft.Devices/iotHubs/Delete",
      "Microsoft.Devices/iotHubs/listkeys/Action",
      "Microsoft.Devices/iotHubs/exportDevices/Action",
      "Microsoft.Devices/iotHubs/importDevices/Action",
      "Microsoft.Devices/iotHubs/operationresults/Read",
      "Microsoft.Devices/iotHubs/iotHubStats/Read",
      "Microsoft.Devices/iotHubs/skus/Read",
      "Microsoft.Devices/iotHubs/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/iotHubs/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/iotHubs/jobs/Read",
      "Microsoft.Devices/iotHubs/quotaMetrics/Read",
      "Microsoft.Devices/iotHubs/routing/$testall/Action",
      "Microsoft.Devices/iotHubs/routing/$testnew/Action",
      "Microsoft.Devices/iotHubs/routingEndpointsHealth/Read",
      "Microsoft.Devices/operations/Read",
      "Microsoft.Devices/usages/Read",
      "Microsoft.Devices/operationresults/Read",
      "Microsoft.Devices/iotHubs/certificates/Read",
      "Microsoft.Devices/iotHubs/certificates/Write",
      "Microsoft.Devices/iotHubs/certificates/Delete",
      "Microsoft.Devices/iotHubs/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/iotHubs/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/Read",
      "Microsoft.Devices/provisioningServices/Write",
      "Microsoft.Devices/provisioningServices/Delete",
      "Microsoft.Devices/provisioningServices/listkeys/Action",
      "Microsoft.Devices/provisioningServices/operationresults/Read",
      "Microsoft.Devices/provisioningServices/skus/Read",
      "Microsoft.Devices/provisioningServices/keys/listkeys/Action",
      "Microsoft.Devices/provisioningServices/certificates/Read",
      "Microsoft.Devices/provisioningServices/certificates/Write",
      "Microsoft.Devices/provisioningServices/certificates/Delete",
      "Microsoft.Devices/provisioningServices/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/provisioningServices/certificates/verify/Action",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/read",
      "Microsoft.Devices/provisioningServices/diagnosticSettings/write",
      "Microsoft.Devices/provisioningServices/metricDefinitions/read",
      "Microsoft.Devices/provisioningServices/logDefinitions/read",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/diagnosticSettings/write",
      "Microsoft.Devices/ElasticPools/IotHubTenants/metricDefinitions/read",
      "Microsoft.Devices/ElasticPools/IotHubTenants/logDefinitions/read",
      "Microsoft.Devices/elasticPools/iotHubTenants/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/listKeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/exportDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/importDevices/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/getStats/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/iotHubKeys/listkeys/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/eventHubEndpoints/consumerGroups/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/jobs/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/quotaMetrics/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testall/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/routing/routes/$testnew/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/routingEndpointsHealth/Read",
      "Microsoft.Devices/iotHubs/eventGridFilters/Write",
      "Microsoft.Devices/iotHubs/eventGridFilters/Read",
      "Microsoft.Devices/iotHubs/eventGridFilters/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Read",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Write",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/Delete",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/generateVerificationCode/Action",
      "Microsoft.Devices/elasticPools/iotHubTenants/certificates/verify/Action",
      "Microsoft.Devices/locations/operationresults/Read",
      "Microsoft.IoTSpaces/register/action",
      "Microsoft.IoTSpaces/Graph/write",
      "Microsoft.IoTSpaces/Graph/read",
      "Microsoft.IoTSpaces/Graph/delete",
    ]
  }
}
